<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTripInsert ArrayType
 * @subpackage Arrays
 */
class ArrayOfTripInsert extends AbstractStructArrayBase
{
    /**
     * The TripInsert
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TripInsert[]
     */
    public $TripInsert;
    /**
     * Constructor method for ArrayOfTripInsert
     * @uses ArrayOfTripInsert::setTripInsert()
     * @param \StructType\TripInsert[] $tripInsert
     */
    public function __construct(array $tripInsert = array())
    {
        $this
            ->setTripInsert($tripInsert);
    }
    /**
     * Get TripInsert value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TripInsert[]|null
     */
    public function getTripInsert()
    {
        return isset($this->TripInsert) ? $this->TripInsert : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTripInsert method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTripInsert method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTripInsertForArrayConstraintsFromSetTripInsert(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTripInsertTripInsertItem) {
            // validation for constraint: itemType
            if (!$arrayOfTripInsertTripInsertItem instanceof \StructType\TripInsert) {
                $invalidValues[] = is_object($arrayOfTripInsertTripInsertItem) ? get_class($arrayOfTripInsertTripInsertItem) : sprintf('%s(%s)', gettype($arrayOfTripInsertTripInsertItem), var_export($arrayOfTripInsertTripInsertItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TripInsert property can only contain items of type \StructType\TripInsert, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TripInsert value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TripInsert[] $tripInsert
     * @return \ArrayType\ArrayOfTripInsert
     */
    public function setTripInsert(array $tripInsert = array())
    {
        // validation for constraint: array
        if ('' !== ($tripInsertArrayErrorMessage = self::validateTripInsertForArrayConstraintsFromSetTripInsert($tripInsert))) {
            throw new \InvalidArgumentException($tripInsertArrayErrorMessage, __LINE__);
        }
        if (is_null($tripInsert) || (is_array($tripInsert) && empty($tripInsert))) {
            unset($this->TripInsert);
        } else {
            $this->TripInsert = $tripInsert;
        }
        return $this;
    }
    /**
     * Add item to TripInsert value
     * @throws \InvalidArgumentException
     * @param \StructType\TripInsert $item
     * @return \ArrayType\ArrayOfTripInsert
     */
    public function addToTripInsert(\StructType\TripInsert $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TripInsert) {
            throw new \InvalidArgumentException(sprintf('The TripInsert property can only contain items of type \StructType\TripInsert, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TripInsert[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TripInsert|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TripInsert|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TripInsert|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TripInsert|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TripInsert|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TripInsert
     */
    public function getAttributeName()
    {
        return 'TripInsert';
    }
}
